diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-phy-reception-test.cc ns-3.43/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.42/src/wifi/test/wifi-phy-reception-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-phy-reception-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -4708,7 +4683,7 @@
      *
      * \param signal the arriving signal
      * \param senderNodeId node Id of the sender of the signal
-     * \param rxPower received signal power (dBm)
+     * \param rxPower received signal power
      * \param duration signal duration
      */
     void RxBegin(Ptr<const SpectrumSignalParameters> signal,
@@ -4733,12 +4708,12 @@
     Ptr<SpectrumWifiPhy> m_tx{nullptr}; ///< transmit function
     Ptr<SpectrumWifiPhy> m_rx{nullptr}; ///< receive function
     uint32_t m_countRxBegin{0};         ///< count of receive events
-    uint16_t m_channel{36};             ///< channel for packet transmission
+    uint8_t m_channel{36};              ///< channel for packet transmission
     uint16_t m_expectedValue{0};        ///< expected count of receive events
 };
 
 TestSpectrumChannelWithBandwidthFilter::TestSpectrumChannelWithBandwidthFilter(
-    uint16_t channel,
+    uint8_t channel,
     uint16_t expectedValue)
     : TestCase("Test for early discard of signal in single-model-spectrum-channel::StartTx()"),
       m_channel(channel),
@@ -4749,8 +4724,15 @@
 void
 TestSpectrumChannelWithBandwidthFilter::Send() const
 {
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs7(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
+    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
+                                         0,
+                                         WIFI_PREAMBLE_HE_SU,
+                                         NanoSeconds(800),
+                                         1,
+                                         1,
+                                         0,
+                                         20,
+                                         false);
 
     Ptr<Packet> pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
@@ -4920,8 +4902,15 @@
 void
 TestPhyDropDueToTx::Send(Ptr<WifiPhy> phy) const
 {
-    const auto txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false);
+    const auto txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                       0,
+                                       WIFI_PREAMBLE_HE_SU,
+                                       NanoSeconds(800),
+                                       1,
+                                       1,
+                                       0,
+                                       20,
+                                       false);
 
     auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-phy-rx-trace-helper-test.cc ns-3.43/src/wifi/test/wifi-phy-rx-trace-helper-test.cc
--- ns-3.42/src/wifi/test/wifi-phy-rx-trace-helper-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-phy-rx-trace-helper-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 #include "ns3/ampdu-tag.h"
 #include "ns3/ap-wifi-mac.h"
@@ -269,8 +258,15 @@
     tx_phy->SetTxPowerStart(txPower);
     tx_phy->SetTxPowerEnd(txPower);
 
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, true);
+    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                         0,
+                                         WIFI_PREAMBLE_HE_SU,
+                                         NanoSeconds(800),
+                                         1,
+                                         1,
+                                         0,
+                                         20,
+                                         true);
 
     std::vector<Ptr<WifiMpdu>> mpduList;
 
@@ -302,8 +298,15 @@
     tx_phy->SetTxPowerStart(txPower);
     tx_phy->SetTxPowerEnd(txPower);
 
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, true);
+    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                         0,
+                                         WIFI_PREAMBLE_HE_SU,
+                                         NanoSeconds(800),
+                                         1,
+                                         1,
+                                         0,
+                                         20,
+                                         true);
 
     std::vector<Ptr<WifiMpdu>> mpduList;
 
@@ -1129,8 +1132,15 @@
     tx_phy->SetTxPowerStart(txPower);
     tx_phy->SetTxPowerEnd(txPower);
 
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, true);
+    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                         0,
+                                         WIFI_PREAMBLE_HE_SU,
+                                         NanoSeconds(800),
+                                         1,
+                                         1,
+                                         0,
+                                         20,
+                                         true);
 
     std::vector<Ptr<WifiMpdu>> mpduList;
 
@@ -1166,7 +1176,7 @@
         WifiTxVector(HePhy::GetHeMcs0(),
                      0,
                      WIFI_PREAMBLE_HE_SU,
-                     800,
+                     NanoSeconds(800),
                      1,
                      1,
                      0,
@@ -1883,8 +1893,15 @@
 {
     propLoss->SetRss(rxPowerDbm);
 
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, true);
+    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                         0,
+                                         WIFI_PREAMBLE_HE_SU,
+                                         NanoSeconds(800),
+                                         1,
+                                         1,
+                                         0,
+                                         20,
+                                         true);
 
     std::vector<Ptr<WifiMpdu>> mpduList;
 
@@ -1922,8 +1939,15 @@
 {
     propLoss->SetRss(rxPowerDbm);
 
-    auto txVector =
-        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, true);
+    auto txVector = WifiTxVector(HePhy::GetHeMcs0(),
+                                 0,
+                                 WIFI_PREAMBLE_HE_SU,
+                                 NanoSeconds(800),
+                                 1,
+                                 1,
+                                 0,
+                                 20,
+                                 true);
 
     std::vector<Ptr<WifiMpdu>> mpduList;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-phy-thresholds-test.cc ns-3.43/src/wifi/test/wifi-phy-thresholds-test.cc
--- ns-3.42/src/wifi/test/wifi-phy-thresholds-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-phy-thresholds-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -40,8 +29,8 @@
 NS_LOG_COMPONENT_DEFINE("WifiPhyThresholdsTest");
 
 static const uint8_t CHANNEL_NUMBER = 36;
-static const uint32_t FREQUENCY = 5180;   // MHz
-static const uint16_t CHANNEL_WIDTH = 20; // MHz
+static const MHz_u FREQUENCY = 5180;
+static const MHz_u CHANNEL_WIDTH = 20;
 
 /**
  * \ingroup wifi-test
@@ -58,32 +47,28 @@
      * \param test_name the test name
      */
     WifiPhyThresholdsTest(std::string test_name);
-    /**
-     * Destructor
-     */
-    ~WifiPhyThresholdsTest() override;
 
   protected:
     /**
      * Make wifi signal function
-     * \param txPowerWatts the transmit power in watts
+     * \param txPower the transmit power
      * \param channel the operating channel of the PHY used for the transmission
      * \returns Ptr<SpectrumSignalParameters>
      */
-    virtual Ptr<SpectrumSignalParameters> MakeWifiSignal(double txPowerWatts,
+    virtual Ptr<SpectrumSignalParameters> MakeWifiSignal(Watt_u txPower,
                                                          const WifiPhyOperatingChannel& channel);
     /**
      * Make foreign signal function
-     * \param txPowerWatts the transmit power in watts
+     * \param txPower the transmit power
      * \returns Ptr<SpectrumSignalParameters>
      */
-    virtual Ptr<SpectrumSignalParameters> MakeForeignSignal(double txPowerWatts);
+    virtual Ptr<SpectrumSignalParameters> MakeForeignSignal(Watt_u txPower);
     /**
      * Send signal function
-     * \param txPowerWatts the transmit power in watts
+     * \param txPower the transmit power
      * \param wifiSignal whether the signal is a wifi signal or not
      */
-    virtual void SendSignal(double txPowerWatts, bool wifiSignal);
+    virtual void SendSignal(Watt_u txPower, bool wifiSignal);
     /**
      * PHY receive success callback function
      * \param psdu the PSDU
@@ -140,41 +125,37 @@
 {
 }
 
-WifiPhyThresholdsTest::~WifiPhyThresholdsTest()
-{
-}
-
 Ptr<SpectrumSignalParameters>
-WifiPhyThresholdsTest::MakeWifiSignal(double txPowerWatts, const WifiPhyOperatingChannel& channel)
+WifiPhyThresholdsTest::MakeWifiSignal(Watt_u txPower, const WifiPhyOperatingChannel& channel)
 {
-    WifiTxVector txVector = WifiTxVector(OfdmPhy::GetOfdmRate6Mbps(),
-                                         0,
-                                         WIFI_PREAMBLE_LONG,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         CHANNEL_WIDTH,
-                                         false);
+    WifiTxVector txVector{OfdmPhy::GetOfdmRate6Mbps(),
+                          0,
+                          WIFI_PREAMBLE_LONG,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          CHANNEL_WIDTH,
+                          false};
 
-    Ptr<Packet> pkt = Create<Packet>(1000);
+    auto pkt = Create<Packet>(1000);
     WifiMacHeader hdr;
 
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
 
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
-    Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
-
-    Ptr<WifiPpdu> ppdu = Create<OfdmPpdu>(psdu, txVector, channel, 0);
-
-    Ptr<SpectrumValue> txPowerSpectrum =
-        WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
-            channel.GetPrimaryChannelCenterFrequency(CHANNEL_WIDTH),
-            CHANNEL_WIDTH,
-            txPowerWatts,
-            CHANNEL_WIDTH);
-    Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
+    const auto txDuration =
+        m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
+
+    auto ppdu = Create<OfdmPpdu>(psdu, txVector, channel, 0);
+
+    auto txPowerSpectrum = WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
+        channel.GetPrimaryChannelCenterFrequency(CHANNEL_WIDTH),
+        CHANNEL_WIDTH,
+        txPower,
+        CHANNEL_WIDTH);
+    auto txParams = Create<WifiSpectrumSignalParameters>();
     txParams->psd = txPowerSpectrum;
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
@@ -183,14 +164,14 @@
 }
 
 Ptr<SpectrumSignalParameters>
-WifiPhyThresholdsTest::MakeForeignSignal(double txPowerWatts)
+WifiPhyThresholdsTest::MakeForeignSignal(Watt_u txPower)
 {
-    Ptr<SpectrumValue> txPowerSpectrum =
+    auto txPowerSpectrum =
         WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(FREQUENCY,
                                                                     CHANNEL_WIDTH,
-                                                                    txPowerWatts,
+                                                                    txPower,
                                                                     CHANNEL_WIDTH);
-    Ptr<SpectrumSignalParameters> txParams = Create<SpectrumSignalParameters>();
+    auto txParams = Create<SpectrumSignalParameters>();
     txParams->psd = txPowerSpectrum;
     txParams->txPhy = nullptr;
     txParams->duration = Seconds(0.5);
@@ -198,15 +179,15 @@
 }
 
 void
-WifiPhyThresholdsTest::SendSignal(double txPowerWatts, bool wifiSignal)
+WifiPhyThresholdsTest::SendSignal(Watt_u txPower, bool wifiSignal)
 {
     if (wifiSignal)
     {
-        m_phy->StartRx(MakeWifiSignal(txPowerWatts, m_phy->GetOperatingChannel()), nullptr);
+        m_phy->StartRx(MakeWifiSignal(txPower, m_phy->GetOperatingChannel()), nullptr);
     }
     else
     {
-        m_phy->StartRx(MakeForeignSignal(txPowerWatts), nullptr);
+        m_phy->StartRx(MakeForeignSignal(txPower), nullptr);
     }
 }
 
@@ -256,13 +237,13 @@
 void
 WifiPhyThresholdsTest::DoSetup()
 {
-    Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
-    Ptr<Node> node = CreateObject<Node>();
-    Ptr<WifiNetDevice> dev = CreateObject<WifiNetDevice>();
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto node = CreateObject<Node>();
+    auto dev = CreateObject<WifiNetDevice>();
     m_phy = CreateObject<SpectrumWifiPhy>();
-    Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
+    auto interferenceHelper = CreateObject<InterferenceHelper>();
     m_phy->SetInterferenceHelper(interferenceHelper);
-    Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
+    auto error = CreateObject<NistErrorRateModel>();
     m_phy->SetErrorRateModel(error);
     m_phy->SetDevice(dev);
     m_phy->AddChannel(spectrumChannel);
@@ -299,7 +280,6 @@
 {
   public:
     WifiPhyThresholdsWeakWifiSignalTest();
-    ~WifiPhyThresholdsWeakWifiSignalTest() override;
     void DoRun() override;
 };
 
@@ -308,19 +288,15 @@
 {
 }
 
-WifiPhyThresholdsWeakWifiSignalTest::~WifiPhyThresholdsWeakWifiSignalTest()
-{
-}
-
 void
 WifiPhyThresholdsWeakWifiSignalTest::DoRun()
 {
-    double txPowerWatts = DbmToW(-110);
+    const auto txPower = DbmToW(-110);
 
     Simulator::Schedule(Seconds(1),
                         &WifiPhyThresholdsWeakWifiSignalTest::SendSignal,
                         this,
-                        txPowerWatts,
+                        txPower,
                         true);
 
     Simulator::Run();
@@ -365,12 +341,12 @@
 void
 WifiPhyThresholdsWeakForeignSignalTest::DoRun()
 {
-    double txPowerWatts = DbmToW(-90);
+    const auto txPower = DbmToW(-90);
 
     Simulator::Schedule(Seconds(1),
                         &WifiPhyThresholdsWeakForeignSignalTest::SendSignal,
                         this,
-                        txPowerWatts,
+                        txPower,
                         false);
 
     Simulator::Run();
@@ -414,12 +390,12 @@
 void
 WifiPhyThresholdsStrongWifiSignalTest::DoRun()
 {
-    double txPowerWatts = DbmToW(-60);
+    const auto txPower = DbmToW(-60);
 
     Simulator::Schedule(Seconds(1),
                         &WifiPhyThresholdsStrongWifiSignalTest::SendSignal,
                         this,
-                        txPowerWatts,
+                        txPower,
                         true);
 
     Simulator::Run();
@@ -467,12 +443,12 @@
 void
 WifiPhyThresholdsStrongForeignSignalTest::DoRun()
 {
-    double txPowerWatts = DbmToW(-60);
+    const auto txPower = DbmToW(-60);
 
     Simulator::Schedule(Seconds(1),
                         &WifiPhyThresholdsStrongForeignSignalTest::SendSignal,
                         this,
-                        txPowerWatts,
+                        txPower,
                         false);
 
     Simulator::Run();
